<?php

namespace JetBackup\Ajax\Calls;

use JetBackup\Ajax\aAjax;
use JetBackup\Exception\AjaxException;
use JetBackup\Exception\IOException;
use JetBackup\Factory;
use JetBackup\Settings\Restore;
use JetBackup\UserInput\UserInput;

if (!defined( '__JETBACKUP__')) die('Direct access is not allowed');

class ManageSettingsRestore extends aAjax {

	/**
	 * @return bool
	 * @throws AjaxException
	 */
	private function _getRestoreCompatibilityCheck(): bool { return $this->getUserInput(Restore::RESTORE_COMPATIBILITY_CHECK, false, UserInput::BOOL); }
	private function _getRestoreAllowCrossDomain(): bool { return $this->getUserInput(Restore::RESTORE_ALLOW_CROSS_DOMAIN, false, UserInput::BOOL); }

	/**
	 * @return void
	 * @throws AjaxException
	 * @throws IOException
	 */
	public function execute(): void {

		$settings = Factory::getSettingsRestore();
		if($this->isset(Restore::RESTORE_COMPATIBILITY_CHECK)) $settings->setRestoreCompatibilityCheck($this->_getRestoreCompatibilityCheck());
		if($this->isset(Restore::RESTORE_ALLOW_CROSS_DOMAIN)) $settings->setRestoreAllowCrossDomain($this->_getRestoreAllowCrossDomain());

		$settings->validateFields();
		$settings->save();

		$this->setResponseMessage('Saved Successfully');
		$this->setResponseData($this->isCLI() ? $settings->getDisplayCLI() : $settings->getDisplay());
	}
}

